package model

import (
	"github.com/jinzhu/gorm"
	"time"
	"fmt"
)

type TProvider struct {
	Id int64 `gorm:"column:id" json:"id" form:"id"`
	Name string `gorm:"column:name" json:"name" form:"name"`
	SocialCode string `gorm:"column:social_code" json:"social_code" form:"social_code"`
	LegalPerson string `gorm:"column:legal_person" json:"legal_person" form:"legal_person"`
	IdCert string `gorm:"column:id_cert" json:"id_cert" form:"id_cert"`
	EnterpriseLocation int32 `gorm:"column:enterprise_location" json:"enterprise_location" form:"enterprise_location"`
	BusinessLicense string `gorm:"column:business_license" json:"business_license" form:"business_license"`
	IntegrityManagementLetter string `gorm:"column:integrity_management_letter" json:"integrity_management_letter" form:"integrity_management_letter"`
	LegalPersonLetter string `gorm:"column:legal_person_letter" json:"legal_person_letter" form:"legal_person_letter"`
	BusinessResponsibleLetter string `gorm:"column:business_responsible_letter" json:"business_responsible_letter" form:"business_responsible_letter"`
	UserName string `gorm:"column:user_name" json:"user_name" form:"user_name"`
	Passwd string `gorm:"column:passwd" json:"passwd" form:"passwd"`
	BusinessContact string `gorm:"column:business_contact" json:"business_contact" form:"business_contact"`
	BusinessContactPhone string `gorm:"column:business_contact_phone" json:"business_contact_phone" form:"business_contact_phone"`
	BusinessResponsible string `gorm:"column:business_responsible" json:"business_responsible" form:"business_responsible"`
	BusinessResponsiblePhone string `gorm:"column:business_responsible_phone" json:"business_responsible_phone" form:"business_responsible_phone"`
	EmergencyContact string `gorm:"column:emergency_contact" json:"emergency_contact" form:"emergency_contact"`
	EmergencyContactPhone string `gorm:"column:emergency_contact_phone" json:"emergency_contact_phone" form:"emergency_contact_phone"`
	Status int64 `gorm:"column:status" json:"status" form:"status"`
	CreatedAt time.Time `gorm:"column:created_at" json:"created_at" form:"created_at"`
	UpdatedAt time.Time `gorm:"column:updated_at" json:"updated_at" form:"updated_at"`
	Feedback string
	ApproveTime time.Time
}

func PublicityList(db *gorm.DB, provider string) ([]TProvider, int64, error) {
	sql := fmt.Sprintf("select t1.* from t_provider as t1  where(select count(1) from t_provider_device where provider_id=t1.id and status = 3) > 0 and t1.status = 1")
	countSql := fmt.Sprintf("select count(1) as count from t_provider as t1  where(select count(1) from t_provider_device where provider_id=t1.id and status = 3) > 0 ")
	type CountResult struct {
		Count int64
	}
	if provider != "" {
		sql = fmt.Sprintf("%s and t1.name like '%%%s%%'", sql, provider)
		countSql = fmt.Sprintf("%s and t1.name like '%%%s%%'", countSql, provider)
	}
	array := []CountResult{}
	err := db.Raw(countSql).Scan(&array).Error
	if err != nil {
		return nil, 0, err
	}
	total := array[0].Count
	if total == 0 {
		return nil, 0, nil
	}
	list := []TProvider{}
	err = db.Raw(sql).Scan(&list).Error
	if err != nil {
		return nil, 0, err
	}
	return list, total, nil
}

